package jbossbugtest.console;

public class Main {
	public static final int SIGNAL_EXIT = 1;

	private boolean exit;

	private static Main staticMain;

	public void run(String[] args) {
		System.out.println("CONTROL INTO MAIN LOOP");
		while(true) {
			System.out.println("MAIN LOOP SLEEP");
			synchronized (this) {
				if(exit)
					break;

				try {
					wait();
				} catch (InterruptedException e) {
				}

				System.out.println("MAIN LOOP WAKEUP");

				if(exit) {
					break;
				}
				// do work here
			}
		}
		System.out.println("CONTROL EXIT MAIN LOOP");
	}

	public void signal(int signalNumber) {
		switch(signalNumber) {
		case SIGNAL_EXIT:
			synchronized (this) {
				exit = true;
				notifyAll();
			}
			break;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			Main main = new Main();
			Main.staticMain = main;
			main.run(args);
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

}
