package jbossbugtest.jboss;

import javax.annotation.PostConstruct;

import jbossbugtest.console.Main;
import org.slf4j.LoggerFactory;

public class ModuleMainThread implements Runnable {
	private Main main;
	private LifecycleListener listener;

	private static final org.slf4j.Logger log = LoggerFactory.getLogger(ModuleMainThread.class);

	public ModuleMainThread(LifecycleListener listener) {
		this.listener = listener;
		main = new Main();
	}

	@PostConstruct
	public void init() {
		log.info("init()");
		log.warn("init()");
		log.error("init()");
	}

	public void signal(int signalNumber) {
		if(main != null)
			main.signal(signalNumber);
	}

	public void run() {
		try {
			if(main != null) {
				String[] args = new String[0];
				main.run(args);
			}
		} catch(Exception e) {
			e.printStackTrace();
		} finally {
			if(listener != null)
				listener.terminated(null);
		}
	}
}
